module.exports =
    class Cargo {
        constructor(banco) {
            this.banco = banco;
            this.idCargo = null;
            this.nomeCargo = null;
        }
        async create() {
            const operacaoAssincrona = new Promise((resolve, reject) => {
                const nomeCargo = this.getNomeCargo();
                let parametros = [nomeCargo];
                let sql = "INSERT INTO cargo (nomeCargo) VALUES (?);";
                this.banco.query(sql, parametros, function (error, result) {
                    if (error) {
                        reject(error);
                    } else {
                        resolve(result);
                    }
                });
            });
            return operacaoAssincrona;
        }
        async read() {
            const operacaoAssincrona = new Promise((resolve, reject) => {
                const id = this.getIdCargo();
                let parametros = [id];
                let sql = "";

                if (id == null) {
                    sql = "SELECT * FROM cargo order by nomeCargo";
                } else {
                    sql = "SELECT * FROM cargo where idCargo=?";
                }
                this.banco.query(sql, parametros, function (error, result) {
                    if (error) {
                        reject(error);
                    } else {
                        resolve(result);
                    }
                });
            });
            return operacaoAssincrona;
        }
        async update() {
            const operacaoAssincrona = new Promise((resolve, reject) => {
                const id = this.getIdCargo();
                const nomeCargo = this.getNomeCargo();
                console.log(nomeCargo);
                let parametros = [nomeCargo, id];
                let sql = "update cargo set nomeCargo=? where idCargo = ?";
                this.banco.query(sql, parametros, function (error, result) {
                    if (error) {
                        reject(error);
                    } else {
                        resolve(result);
                    }
                });
            });

            return operacaoAssincrona;
        }
        async delete() {
            const operacaoAssincrona = new Promise((resolve, reject) => {

                let parametros = [this.idCargo];
                let sql = "delete from cargo where idCargo=?";
                this.banco.query(sql, parametros, function (error, result) {
                    if (error) {
                        reject(error);
                    } else {
                        resolve(result);
                    }
                });
            });
            return operacaoAssincrona;
        }
        async exists() {
            const operacaoAssincrona = new Promise((resolve, reject) => {
                let parametros = [this.nomeCargo, this.idCargo];
                let sql = "update cargo set nomeCargo=? where idCargo = ?";
                this.banco.query(sql, parametros, function (error, result) {
                    if (error) {
                        reject(error);
                    } else {
                        resolve(result);
                    }
                });
            });
            return operacaoAssincrona;
        }


        setIdCargo(idCargo) {
            this.idCargo = idCargo;
        }
        getIdCargo() {
            return this.idCargo;
        }
        setNomeCargo(nomeCargo) {
            this.nomeCargo = nomeCargo;
        }
        getNomeCargo() {
            return this.nomeCargo;
        }

    }

