//
var md5 = require('md5'); //npm install md5 --save  //https://www.npmjs.com/package/md5

module.exports = class Funcionario {

    constructor(banco) {
        this.banco = banco;
        this.id = null;
        this.nome = null;
        this.email = null;
        this.senha = null;
        this.recebeValeTransporte = null;
        this.cargo = {
            idCargo: null,
            nomeCargo: null
        };
    }

    async create() {
        const operacaoAssincrona = new Promise((resolve, reject) => {
            const nome = this.getNome();
            const email = this.getEmail();
            const senha = md5(this.getSenha());
            const recebeValeTransporte = this.getRecebeValeTransporte();
            const cargo = this.getCargo();
            const Cargo_idCargo = cargo.idCargo;

            const params = [nome, email, senha, recebeValeTransporte, Cargo_idCargo];

            let sql = "INSERT INTO funcionario (nome, email,senha, recebeValeTransporte, Cargo_idCargo) VALUES (?, ?, ?, ?, ?);";

            this.banco.query(sql, params, function (error, result) {
                if (error) {
                    reject(error);
                } else {
                    resolve(result);
                }
            });
        });
        return operacaoAssincrona;
    }
    async read() {
        const operacaoAssincrona = new Promise((resolve, reject) => {

            const id = this.getIdFuncionario();
            let params = [id];
            let SQL = "";
            console.log(id);
            if (id == null) {
                SQL = "SELECT idFuncionario,nome,email,recebeValeTransporte,idCargo,nomeCargo FROM funcionario JOIN cargo ON cargo.idCargo = funcionario.Cargo_idCargo  ORDER BY nome, nomeCargo";
            } else {
                SQL = "SELECT idFuncionario,nome,email,recebeValeTransporte,idCargo,nomeCargo FROM funcionario JOIN cargo ON cargo.idCargo = funcionario.Cargo_idCargo where idFuncionario=? ORDER BY nome, nomeCargo ";
            }
            this.banco.query(SQL, params, function (error, result) {
                if (error) {
                    console.log(error);
                    reject(error);
                } else {

                    resolve(result);
                }
            });
        });
        return operacaoAssincrona;
    }

    async update() {
        const operacaoAssincrona = new Promise((resolve, reject) => {
            const nome = this.getNome();
            const email = this.getEmail();
            const senha = md5(this.getSenha());
            const recebeValeTransporte = this.getRecebeValeTransporte();
            const Cargo_idCargo = this.getCargo().idCargo;
            const idFuncionario = this.getIdFuncionario();

            let parametros = [nome, email, senha, recebeValeTransporte, Cargo_idCargo, idFuncionario];
            let sql = "update funcionario set nome=?,email=?,senha=?,recebeValeTransporte=?,Cargo_idCargo =? where idFuncionario = ?";
            this.banco.query(sql, parametros, function (error, result) {
                if (error) {
                    reject(error);
                } else {
                    resolve(result);
                }
            });
        });
        return operacaoAssincrona;
    }

    async delete() {
        const operacaoAssincrona = new Promise((resolve, reject) => {
            const idFuncionario = this.getIdFuncionario();
            let parametros = [idFuncionario];
            let sql = "delete from funcionario where idFuncionario = ?";
            this.banco.query(sql, parametros, function (error, result) {
                if (error) {
                    reject(error);
                } else {
                    resolve(result);
                }
            });
        });
        return operacaoAssincrona;
    }


    async login() {
        const operacaoAssincrona = new Promise((resolve, reject) => {
            const email = this.getEmail();
            const senha = md5(this.getSenha());
            let parametros = [email, senha];
            let sql = "SELECT COUNT(*) AS qtd ,nome,email FROM funcionario WHERE email =? AND senha =?";

            const result = this.banco.query(sql, parametros, (error, result) => {
                if (error) {
                    reject(error);
                } else {

                    if (result[0].qtd == 1) {
                        const resposta = {
                            status: true,
                            nome: result[0].nome,
                            email: result[0].email
                        }
                        resolve(resposta);
                    } else {
                        const resposta = {
                            status: false,
                        }
                        resolve(resposta);
                    }

                }
            });
        });
        return operacaoAssincrona;
    }


    setIdFuncionario(idFuncionario) {
        this.idFuncionario = idFuncionario
    }
    getIdFuncionario() {
        return this.idFuncionario
    }
    setNome(name) {
        this.nome = name;
    }
    getNome() {
        return this.nome;
    }
    setEmail(email) {
        this.email = email;
    }
    getEmail() {
        return this.email;
    }

    setSenha(senha) {
        this.senha = senha;
    }
    getSenha() {
        return this.senha;
    }
    setRecebeValeTransporte(recebeValeTransporte) {
        this.recebeValeTransporte = recebeValeTransporte;
    }
    getRecebeValeTransporte() {
        return this.recebeValeTransporte;
    }

    setCargo(cargo) {
        this.cargo = cargo;
    }
    getCargo() {
        return this.cargo;
    }


}

