const Cargo = require("../modelo/Cargo");
const JwtToken = require('../modelo/JwtToken'); // npm install jsonwebtoken --save        https://www.npmjs.com/package/jsonwebtoken
module.exports = function (app, banco) {

    app.post('/cargos', (request, response) => {
        console.log("rota: POST: /cargos");
        const nomeCargo = request.body.nomeCargo;

        if (nomeCargo == "") {
            const resposta = {
                status: true,
                msg: 'o nome não pode ser vazio',
                codigo: '001',
                dados: resultadosBanco,
            }
            response.status(200).send(resposta);
        } else if (nomeCargo.length < 3) {

        } else {

            const cargo = new Cargo(banco);
            cargo.setNomeCargo(nomeCargo);

            cargo.create().then((resultadosBanco) => {
                const resposta = {
                    status: true,
                    msg: 'Executado com sucesso',
                    codigo: '004',
                    dados: {
                        idCargo: resultadosBanco.insertId,
                        nomeCargo: cargo.getNomeCargo()
                    }
                }
                response.status(201).send(resposta);

            }).catch((erro) => {
                const resposta = {
                    status: false,
                    msg: 'erro ao executar',
                    codigo: '005',
                    dados: erro,
                }
                response.status(200).send(resposta);
            });;
        }
    });
    /**
     * 
     */
    app.get('/cargos', (request, response) => {
        console.log("rota: GET: /cargos");
        const dadosAutorizacao = request.headers.authorization;
        const jwt = new JwtToken();

        if (jwt.validarToken(dadosAutorizacao).status == true) {

            const cargo = new Cargo(banco);
            cargo.read().then((resultadosBanco) => {
                const resposta = {
                    status: true,
                    msg: 'Executado com sucesso',
                    codigo: 'cargo_002',
                    dados: resultadosBanco
                }
                response.status(200).send(resposta);
            }).catch((erro) => {
                const resposta = {
                    status: false,
                    msg: 'erro ao executar',
                    codigo: 'cargo_E002',
                    dados: erro,
                }
                response.status(200).send(resposta);
            });;
        } else {
            const resposta = {
                status: false,
                msg: 'Usuário não logado',
                codigo: 401
            }
            response.status(200).send(resposta);

        }

    });

    app.get('/cargos/:id/', function (request, response) {

        const cargo = new Cargo(banco);
        const idCargo = request.params.id;

        cargo.setIdCargo(idCargo);
        cargo.read().then((resultadosBanco) => {

            const resposta =
            {
                status: true,
                msg: 'Executado com sucesso',
                codigo: 'cargo_003',
                dados: resultadosBanco
            }

            response.status(200).send(resposta);
        }).catch((erro) => {
            const resposta = {
                status: false,
                msg: 'erro ao executar',
                codigo: 'cargo_E002',
                dados: erro,
            }
            response.status(200).send(resposta);
        });;
    });

    app.put('/cargos/:id/', function (request, response) {


        const idCargo = request.params.id;
        const nomeCargo = request.body.nomeCargo;

        const cargo = new Cargo(banco);
        cargo.setIdCargo(idCargo);
        cargo.setNomeCargo(nomeCargo);

        cargo.update().then((resultadosBanco) => {

            const resposta = {
                status: true,
                msg: 'Executado com sucesso',
                codigo: 'cargo_004',
                dados: {
                    id: cargo.idCargo,
                    nomeCargo: cargo.nomeCargo
                }
            };

            response.status(200).send(resposta);
        }).catch((erro) => {
            const resposta = {
                status: false,
                msg: 'erro ao executar',
                codigo: 'cargo_E002',
                dados: erro,
            }
            response.status(200).send(resposta);
        });;
    });

    app.delete('/cargos/:id/', function (request, response) {


        const idCargo = request.params.id;

        const cargo = new Cargo(banco);
        cargo.setIdCargo(idCargo);

        cargo.delete().then((resultadosBanco) => {

            const resposta = {
                status: true,
                msg: 'Excluido com sucesso com sucesso',
                codigo: 'cargo_004',
                dados: {
                    id: cargo.idCargo
                }
            };

            response.status(200).send(resposta);
        }).catch((erro) => {
            const resposta = {
                status: false,
                msg: 'erro ao executar',
                codigo: 'cargo_E002',
                dados: erro,
            }
            response.status(200).send(resposta);
        });;
    });

};